### Hierarchy

- DisplayObject
  - Tilemap

### Implements

- IEventDispatcher
- IBitmapDrawable
- ITileContainer

## Index

### Constructors

- constructor

### Properties

- alpha
- blendMode
- cacheAsBitmap
- cacheAsBitmapMatrix
- filters
- height
- loaderInfo
- mask
- mouseX
- mouseY
- name
- numTiles
- opaqueBackground
- parent
- root
- rotation
- scale9Grid
- scaleX
- scaleY
- scrollRect
- shader
- smoothing
- stage
- tileAlphaEnabled
- tileColorTransformEnabled
- tileset
- transform
- visible
- width
- x
- y

### Methods

- addEventListener
- addTile
- addTileAt
- addTiles
- contains
- dispatchEvent
- getBounds
- getRect
- getTileAt
- getTileIndex
- getTiles
- get_alpha
- get_blendMode
- get_cacheAsBitmap
- get_cacheAsBitmapMatrix
- get_filters
- get_height
- get_loaderInfo
- get_mask
- get_mouseX
- get_mouseY
- get_name
- get_numTiles
- get_root
- get_rotation
- get_scaleX
- get_scaleY
- get_scrollRect
- get_shader
- get_stage
- get_tileset
- get_transform
- get_visible
- get_width
- get_x
- get_y
- globalToLocal
- hasEventListener
- hitTestObject
- hitTestPoint
- invalidate
- localToGlobal
- removeEventListener
- removeTile
- removeTileAt
- removeTiles
- setTileIndex
- setTiles
- set_alpha
- set_blendMode
- set_cacheAsBitmap
- set_cacheAsBitmapMatrix
- set_filters
- set_height
- set_mask
- set_name
- set_rotation
- set_scaleX
- set_scaleY
- set_scrollRect
- set_shader
- set_stage
- set_tileset
- set_transform
- set_visible
- set_width
- set_x
- set_y
- swapTiles
- swapTilesAt
- toString
- willTrigger

## Constructors

### constructor

- new Tilemap(width: number, height: number, tileset?: Tileset, smoothing?: boolean): Tilemap

- Overrides EventDispatcher.constructor

  - Defined in lib/openfl/display/Tilemap.d.ts:25

  #### Parameters

  - ##### width: number

  - ##### height: number

  - ##### Optional tileset: Tileset

  - ##### Optional smoothing: boolean

  #### Returns Tilemap

## Properties

### alpha

alpha: number

Inherited from DisplayObject.alpha

- Defined in lib/openfl/display/DisplayObject.d.ts:161

Indicates the alpha transparency value of the object specified. Valid values are 0(fully transparent) to 1(fully opaque). The default value is

1. Display objects with `alpha` set to 0 are active, even though they are invisible.

### blendMode

blendMode: BlendMode

Inherited from DisplayObject.blendMode

- Defined in lib/openfl/display/DisplayObject.d.ts:190

A value from the BlendMode class that specifies which blend mode to use. A bitmap can be drawn internally in two ways. If you have a blend mode enabled or an external clipping mask, the bitmap is drawn by adding a bitmap-filled square shape to the vector render. If you attempt to set this property to an invalid value, Flash runtimes set the value to `BlendMode.NORMAL`.

The `blendMode` property affects each pixel of the display object. Each pixel is composed of three constituent colors(red, green, and blue), and each constituent color has a value between 0x00 and 0xFF. Flash Player or Adobe AIR compares each constituent color of one pixel in the movie clip with the corresponding color of the pixel in the background. For example, if `blendMode` is set to `BlendMode.LIGHTEN`, Flash Player or Adobe AIR compares the red value of the display object with the red value of the background, and uses the lighter of the two as the value for the red component of the displayed color.

The following table describes the `blendMode` settings. The BlendMode class defines string values you can use. The illustrations in the table show `blendMode` values applied to a circular display object(2) superimposed on another display object(1).

### cacheAsBitmap

cacheAsBitmap: boolean

Inherited from DisplayObject.cacheAsBitmap

- Defined in lib/openfl/display/DisplayObject.d.ts:251

All vector data for a display object that has a cached bitmap is drawn to the bitmap instead of the main display. If `cacheAsBitmapMatrix` is null or unsupported, the bitmap is then copied to the main display as unstretched, unrotated pixels snapped to the nearest pixel boundaries. Pixels are mapped 1 to 1 with the parent object. If the bounds of the bitmap change, the bitmap is recreated instead of being stretched.

If `cacheAsBitmapMatrix` is non-null and supported, the object is drawn to the off-screen bitmap using that matrix and the stretched and/or rotated results of that rendering are used to draw the object to the main display.

No internal bitmap is created unless the `cacheAsBitmap` property is set to `true`.

After you set the `cacheAsBitmap` property to `true`, the rendering does not change, however the display object performs pixel snapping automatically. The animation speed can be significantly faster depending on the complexity of the vector content.

The `cacheAsBitmap` property is automatically set to `true` whenever you apply a filter to a display object(when its `filter` array is not empty), and if a display object has a filter applied to it, `cacheAsBitmap` is reported as `true` for that display object, even if you set the property to `false`. If you clear all filters for a display object, the `cacheAsBitmap` setting changes to what it was last set to.

A display object does not use a bitmap even if the `cacheAsBitmap` property is set to `true` and instead renders from vector data in the following cases:

- The bitmap is too large. In AIR 1.5 and Flash Player 10, the maximum size for a bitmap image is 8,191 pixels in width or height, and the total number of pixels cannot exceed 16,777,215 pixels.(So, if a bitmap image is 8,191 pixels wide, it can only be 2,048 pixels high.) In Flash Player 9 and earlier, the limitation is is 2880 pixels in height and 2,880 pixels in width.
- The bitmap fails to allocate(out of memory error).

The `cacheAsBitmap` property is best used with movie clips that have mostly static content and that do not scale and rotate frequently. With such movie clips, `cacheAsBitmap` can lead to performance increases when the movie clip is translated(when its _x_ and _y_ position is changed).

### cacheAsBitmapMatrix

cacheAsBitmapMatrix: Matrix

Inherited from DisplayObject.cacheAsBitmapMatrix

- Defined in lib/openfl/display/DisplayObject.d.ts:256

### filters

filters: Array<BitmapFilter>

Inherited from DisplayObject.filters

- Defined in lib/openfl/display/DisplayObject.d.ts:337

An indexed array that contains each filter object currently associated with the display object. The openfl.filters package contains several classes that define specific filters you can use.

Filters can be applied in Flash Professional at design time, or at run time by using ActionScript code. To apply a filter by using ActionScript, you must make a temporary copy of the entire `filters` array, modify the temporary array, then assign the value of the temporary array back to the `filters` array. You cannot directly add a new filter object to the `filters` array.

To add a filter by using ActionScript, perform the following steps (assume that the target display object is named `myDisplayObject`):

1. Create a new filter object by using the constructor method of your chosen filter class.
2. Assign the value of the `myDisplayObject.filters` array to a temporary array, such as one named `myFilters`.
3. Add the new filter object to the `myFilters` temporary array.
4. Assign the value of the temporary array to the `myDisplayObject.filters` array.

If the `filters` array is undefined, you do not need to use a temporary array. Instead, you can directly assign an array literal that contains one or more filter objects that you create. The first example in the Examples section adds a drop shadow filter by using code that handles both defined and undefined `filters` arrays.

To modify an existing filter object, you must use the technique of modifying a copy of the `filters` array:

1. Assign the value of the `filters` array to a temporary array, such as one named `myFilters`.
2. Modify the property by using the temporary array, `myFilters`. For example, to set the quality property of the first filter in the array, you could use the following code: `myFilters[0].quality = 1;`
3. Assign the value of the temporary array to the `filters` array.

At load time, if a display object has an associated filter, it is marked to cache itself as a transparent bitmap. From this point forward, as long as the display object has a valid filter list, the player caches the display object as a bitmap. This source bitmap is used as a source image for the filter effects. Each display object usually has two bitmaps: one with the original unfiltered source display object and another for the final image after filtering. The final image is used when rendering. As long as the display object does not change, the final image does not need updating.

The openfl.filters package includes classes for filters. For example, to create a DropShadow filter, you would write:

throws

  ArgumentError When `filters` includes a ShaderFilter and the shader output type is not compatible with this operation(the shader must specify a `pixel4` output).

throws

  ArgumentError When `filters` includes a ShaderFilter and the shader doesn't specify any image input or the first input is not an `image4` input.

throws

  ArgumentError When `filters` includes a ShaderFilter and the shader specifies an image input that isn't provided.

throws

  ArgumentError When `filters` includes a ShaderFilter, a ByteArray or Vector.<Number> instance as a shader input, and the `width` and `height` properties aren't specified for the ShaderInput object, or the specified values don't match the amount of data in the input data. See the `ShaderInput.input` property for more information.

### height

height: number

Inherited from DisplayObject.height

- Defined in lib/openfl/display/DisplayObject.d.ts:352

Indicates the height of the display object, in pixels. The height is calculated based on the bounds of the content of the display object. When you set the `height` property, the `scaleY` property is adjusted accordingly, as shown in the following code:

Except for TextField and Video objects, a display object with no content(such as an empty sprite) has a height of 0, even if you try to set `height` to a different value.

### loaderInfo

loaderInfo: LoaderInfo

Inherited from DisplayObject.loaderInfo

- Defined in lib/openfl/display/DisplayObject.d.ts:370

Returns a LoaderInfo object containing information about loading the file to which this display object belongs. The `loaderInfo` property is defined only for the root display object of a SWF file or for a loaded Bitmap(not for a Bitmap that is drawn with ActionScript). To find the `loaderInfo` object associated with the SWF file that contains a display object named `myDisplayObject`, use `myDisplayObject.root.loaderInfo`.

A large SWF file can monitor its download by calling `this.root.loaderInfo.addEventListener(Event.COMPLETE, func)`.

### mask

mask: DisplayObject

Inherited from DisplayObject.mask

- Defined in lib/openfl/display/DisplayObject.d.ts:405

The calling display object is masked by the specified `mask` object. To ensure that masking works when the Stage is scaled, the `mask` display object must be in an active part of the display list. The `mask` object itself is not drawn. Set `mask` to `null` to remove the mask.

To be able to scale a mask object, it must be on the display list. To be able to drag a mask Sprite object(by calling its `startDrag()` method), it must be on the display list. To call the `startDrag()` method for a mask sprite based on a `mouseDown` event being dispatched by the sprite, set the sprite's `buttonMode` property to `true`.

When display objects are cached by setting the `cacheAsBitmap` property to `true` an the `cacheAsBitmapMatrix` property to a Matrix object, both the mask and the display object being masked must be part of the same cached bitmap. Thus, if the display object is cached, then the mask must be a child of the display object. If an ancestor of the display object on the display list is cached, then the mask must be a child of that ancestor or one of its descendents. If more than one ancestor of the masked object is cached, then the mask must be a descendent of the cached container closest to the masked object in the display list.

Note: A single `mask` object cannot be used to mask more than one calling display object. When the `mask` is assigned to a second display object, it is removed as the mask of the first object, and that object's `mask` property becomes `null`.

### mouseX

mouseX: number

Inherited from DisplayObject.mouseX

- Defined in lib/openfl/display/DisplayObject.d.ts:417

Indicates the x coordinate of the mouse or user input device position, in pixels.

Note: For a DisplayObject that has been rotated, the returned x coordinate will reflect the non-rotated object.

### mouseY

mouseY: number

Inherited from DisplayObject.mouseY

- Defined in lib/openfl/display/DisplayObject.d.ts:428

Indicates the y coordinate of the mouse or user input device position, in pixels.

Note: For a DisplayObject that has been rotated, the returned y coordinate will reflect the non-rotated object.

### name

name: string

Inherited from DisplayObject.name

- Defined in lib/openfl/display/DisplayObject.d.ts:442

Indicates the instance name of the DisplayObject. The object can be identified in the child list of its parent display object container by calling the `getChildByName()` method of the display object container.

throws

  IllegalOperationError If you are attempting to set this property on an object that was placed on the timeline in the Flash authoring tool.

### numTiles

numTiles: number

- Defined in lib/openfl/display/Tilemap.d.ts:15

### opaqueBackground

opaqueBackground: number | null

Inherited from DisplayObject.opaqueBackground

- Defined in lib/openfl/display/DisplayObject.d.ts:471

Specifies whether the display object is opaque with a certain background color. A transparent bitmap contains alpha channel data and is drawn transparently. An opaque bitmap has no alpha channel(and renders faster than a transparent bitmap). If the bitmap is opaque, you specify its own background color to use.

If set to a number value, the surface is opaque(not transparent) with the RGB background color that the number specifies. If set to `null`(the default value), the display object has a transparent background.

The `opaqueBackground` property is intended mainly for use with the `cacheAsBitmap` property, for rendering optimization. For display objects in which the `cacheAsBitmap` property is set to true, setting `opaqueBackground` can improve rendering performance.

The opaque background region is not matched when calling the `hitTestPoint()` method with the `shapeFlag` parameter set to `true`.

The opaque background region does not respond to mouse events.

### parent

parent: DisplayObjectContainer

Inherited from DisplayObject.parent

- Defined in lib/openfl/display/DisplayObject.d.ts:487

Indicates the DisplayObjectContainer object that contains this display object. Use the `parent` property to specify a relative path to display objects that are above the current display object in the display list hierarchy.

You can use `parent` to move up multiple levels in the display list as in the following:

throws

  SecurityError The parent display object belongs to a security sandbox to which you do not have access. You can avoid this situation by having the parent movie call the `Security.allowDomain()` method.

### root

root: DisplayObject

Inherited from DisplayObject.root

- Defined in lib/openfl/display/DisplayObject.d.ts:515

For a display object in a loaded SWF file, the `root` property is the top-most display object in the portion of the display list's tree structure represented by that SWF file. For a Bitmap object representing a loaded image file, the `root` property is the Bitmap object itself. For the instance of the main class of the first SWF file loaded, the `root` property is the display object itself. The `root` property of the Stage object is the Stage object itself. The `root` property is set to `null` for any display object that has not been added to the display list, unless it has been added to a display object container that is off the display list but that is a child of the top-most display object in a loaded SWF file.

For example, if you create a new Sprite object by calling the `Sprite()` constructor method, its `root` property is `null` until you add it to the display list(or to a display object container that is off the display list but that is a child of the top-most display object in a SWF file).

For a loaded SWF file, even though the Loader object used to load the file may not be on the display list, the top-most display object in the SWF file has its `root` property set to itself. The Loader object does not have its `root` property set until it is added as a child of a display object for which the `root` property is set.

### rotation

rotation: number

Inherited from DisplayObject.rotation

- Defined in lib/openfl/display/DisplayObject.d.ts:527

Indicates the rotation of the DisplayObject instance, in degrees, from its original orientation. Values from 0 to 180 represent clockwise rotation; values from 0 to -180 represent counterclockwise rotation. Values outside this range are added to or subtracted from 360 to obtain a value within the range. For example, the statement `my_video.rotation = 450` is the same as `my_video.rotation = 90`.

### scale9Grid

scale9Grid: Rectangle

Inherited from DisplayObject.scale9Grid

- Defined in lib/openfl/display/DisplayObject.d.ts:594

The current scaling grid that is in effect. If set to `null`, the entire display object is scaled normally when any scale transformation is applied.

When you define the `scale9Grid` property, the display object is divided into a grid with nine regions based on the `scale9Grid` rectangle, which defines the center region of the grid. The eight other regions of the grid are the following areas:

- The upper-left corner outside of the rectangle
- The area above the rectangle
- The upper-right corner outside of the rectangle
- The area to the left of the rectangle
- The area to the right of the rectangle
- The lower-left corner outside of the rectangle
- The area below the rectangle
- The lower-right corner outside of the rectangle

You can think of the eight regions outside of the center(defined by the rectangle) as being like a picture frame that has special rules applied to it when scaled.

When the `scale9Grid` property is set and a display object is scaled, all text and gradients are scaled normally; however, for other types of objects the following rules apply:

- Content in the center region is scaled normally.
- Content in the corners is not scaled.
- Content in the top and bottom regions is scaled horizontally only. Content in the left and right regions is scaled vertically only.
- All fills(including bitmaps, video, and gradients) are stretched to fit their shapes.

If a display object is rotated, all subsequent scaling is normal(and the `scale9Grid` property is ignored).

For example, consider the following display object and a rectangle that is applied as the display object's `scale9Grid`:

A common use for setting `scale9Grid` is to set up a display object to be used as a component, in which edge regions retain the same width when the component is scaled.

throws

  ArgumentError If you pass an invalid argument to the method.

### scaleX

scaleX: number

Inherited from DisplayObject.scaleX

- Defined in lib/openfl/display/DisplayObject.d.ts:604

Indicates the horizontal scale(percentage) of the object as applied from the registration point. The default registration point is(0,0). 1.0 equals 100% scale.

Scaling the local coordinate system changes the `x` and `y` property values, which are defined in whole pixels.

### scaleY

scaleY: number

Inherited from DisplayObject.scaleY

- Defined in lib/openfl/display/DisplayObject.d.ts:617

Indicates the vertical scale(percentage) of an object as applied from the registration point of the object. The default registration point is(0,0). 1.0 is 100% scale.

Scaling the local coordinate system changes the `x` and `y` property values, which are defined in whole pixels.

### scrollRect

scrollRect: Rectangle

Inherited from DisplayObject.scrollRect

- Defined in lib/openfl/display/DisplayObject.d.ts:648

The scroll rectangle bounds of the display object. The display object is cropped to the size defined by the rectangle, and it scrolls within the rectangle when you change the `x` and `y` properties of the `scrollRect` object.

The properties of the `scrollRect` Rectangle object use the display object's coordinate space and are scaled just like the overall display object. The corner bounds of the cropped window on the scrolling display object are the origin of the display object(0,0) and the point defined by the width and height of the rectangle. They are not centered around the origin, but use the origin to define the upper-left corner of the area. A scrolled display object always scrolls in whole pixel increments.

You can scroll an object left and right by setting the `x` property of the `scrollRect` Rectangle object. You can scroll an object up and down by setting the `y` property of the `scrollRect` Rectangle object. If the display object is rotated 90° and you scroll it left and right, the display object actually scrolls up and down.

### shader

shader: Shader

Inherited from DisplayObject.shader

- Defined in lib/openfl/display/DisplayObject.d.ts:653

### smoothing

smoothing: boolean

- Defined in lib/openfl/display/Tilemap.d.ts:19

### stage

stage: Stage

Inherited from DisplayObject.stage

- Defined in lib/openfl/display/DisplayObject.d.ts:668

The Stage of the display object. A Flash runtime application has only one Stage object. For example, you can create and load multiple display objects into the display list, and the `stage` property of each display object refers to the same Stage object(even if the display object belongs to a loaded SWF file).

If a display object is not added to the display list, its `stage` property is set to `null`.

### tileAlphaEnabled

tileAlphaEnabled: Boolean

- Defined in lib/openfl/display/Tilemap.d.ts:20

### tileColorTransformEnabled

tileColorTransformEnabled: Boolean

- Defined in lib/openfl/display/Tilemap.d.ts:21

### tileset

tileset: Tileset

- Defined in lib/openfl/display/Tilemap.d.ts:22

### transform

transform: Transform

Inherited from DisplayObject.transform

- Defined in lib/openfl/display/DisplayObject.d.ts:711

An object with properties pertaining to a display object's matrix, color transform, and pixel bounds. The specific properties - matrix, colorTransform, and three read-only properties (`concatenatedMatrix`, `concatenatedColorTransform`, and `pixelBounds`) - are described in the entry for the Transform class.

Each of the transform object's properties is itself an object. This concept is important because the only way to set new values for the matrix or colorTransform objects is to create a new object and copy that object into the transform.matrix or transform.colorTransform property.

For example, to increase the `tx` value of a display object's matrix, you must make a copy of the entire matrix object, then copy the new object into the matrix property of the transform object: `var myMatrix:Matrix = myDisplayObject.transform.matrix; myMatrix.tx += 10; myDisplayObject.transform.matrix = myMatrix;`

You cannot directly set the `tx` property. The following code has no effect on `myDisplayObject`: `myDisplayObject.transform.matrix.tx += 10;`

You can also copy an entire transform object and assign it to another display object's transform property. For example, the following code copies the entire transform object from `myOldDisplayObj` to `myNewDisplayObj`: `myNewDisplayObj.transform = myOldDisplayObj.transform;`

The resulting display object, `myNewDisplayObj`, now has the same values for its matrix, color transform, and pixel bounds as the old display object, `myOldDisplayObj`.

Note that AIR for TV devices use hardware acceleration, if it is available, for color transforms.

### visible

visible: boolean

Inherited from DisplayObject.visible

- Defined in lib/openfl/display/DisplayObject.d.ts:721

Whether or not the display object is visible. Display objects that are not visible are disabled. For example, if `visible=false` for an InteractiveObject instance, it cannot be clicked.

### width

width: number

Inherited from DisplayObject.width

- Defined in lib/openfl/display/DisplayObject.d.ts:736

Indicates the width of the display object, in pixels. The width is calculated based on the bounds of the content of the display object. When you set the `width` property, the `scaleX` property is adjusted accordingly, as shown in the following code:

Except for TextField and Video objects, a display object with no content(such as an empty sprite) has a width of 0, even if you try to set `width` to a different value.

### x

x: number

Inherited from DisplayObject.x

- Defined in lib/openfl/display/DisplayObject.d.ts:751

Indicates the _x_ coordinate of the DisplayObject instance relative to the local coordinates of the parent DisplayObjectContainer. If the object is inside a DisplayObjectContainer that has transformations, it is in the local coordinate system of the enclosing DisplayObjectContainer. Thus, for a DisplayObjectContainer rotated 90° counterclockwise, the DisplayObjectContainer's children inherit a coordinate system that is rotated 90° counterclockwise. The object's coordinates refer to the registration point position.

### y

y: number

Inherited from DisplayObject.y

- Defined in lib/openfl/display/DisplayObject.d.ts:766

Indicates the _y_ coordinate of the DisplayObject instance relative to the local coordinates of the parent DisplayObjectContainer. If the object is inside a DisplayObjectContainer that has transformations, it is in the local coordinate system of the enclosing DisplayObjectContainer. Thus, for a DisplayObjectContainer rotated 90° counterclockwise, the DisplayObjectContainer's children inherit a coordinate system that is rotated 90° counterclockwise. The object's coordinates refer to the registration point position.

## Methods

### addEventListener

- addEventListener(type: string, listener: function, useCapture?: boolean, priority?: number, useWeakReference?: boolean): void

- Inherited from EventDispatcher.addEventListener

  - Defined in lib/openfl/events/EventDispatcher.d.ts:168

  Registers an event listener object with an EventDispatcher object so that the listener receives notification of an event. You can register event listeners on all nodes in the display list for a specific type of event, phase, and priority.

  After you successfully register an event listener, you cannot change its priority through additional calls to `addEventListener()`. To change a listener's priority, you must first call `removeListener()`. Then you can register the listener again with the new priority level.

  Keep in mind that after the listener is registered, subsequent calls to `addEventListener()` with a different `type` or `useCapture` value result in the creation of a separate listener registration. For example, if you first register a listener with `useCapture` set to `true`, it listens only during the capture phase. If you call `addEventListener()` again using the same listener object, but with `useCapture` set to `false`, you have two separate listeners: one that listens during the capture phase and another that listens during the target and bubbling phases.

  You cannot register an event listener for only the target phase or the bubbling phase. Those phases are coupled during registration because bubbling applies only to the ancestors of the target node.

  If you no longer need an event listener, remove it by calling `removeEventListener()`, or memory problems could result. Event listeners are not automatically removed from memory because the garbage collector does not remove the listener as long as the dispatching object exists(unless the `useWeakReference` parameter is set to `true`).

  Copying an EventDispatcher instance does not copy the event listeners attached to it.(If your newly created node needs an event listener, you must attach the listener after creating the node.) However, if you move an EventDispatcher instance, the event listeners attached to it move along with it.

  If the event listener is being registered on a node while an event is being processed on this node, the event listener is not triggered during the current phase but can be triggered during a later phase in the event flow, such as the bubbling phase.

  If an event listener is removed from a node while an event is being processed on the node, it is still triggered by the current actions. After it is removed, the event listener is never invoked again(unless registered again for future processing).

  throws

    ArgumentError The `listener` specified is not a function.

  #### Parameters

  - ##### type: string

    The type of event.

  - ##### listener: function

    - - (event: object): void

      - #### Parameters

        - ##### event: object

        #### Returns void

  - ##### Optional useCapture: boolean

    Determines whether the listener works in the capture phase or the target and bubbling phases. If `useCapture` is set to `true`, the listener processes the event only during the capture phase and not in the target or bubbling phase. If `useCapture` is `false`, the listener processes the event only during the target or bubbling phase. To listen for the event in all three phases, call `addEventListener` twice, once with `useCapture` set to `true`, then again with `useCapture` set to `false`.

  - ##### Optional priority: number

    The priority level of the event listener. The priority is designated by a signed 32-bit integer. The higher the number, the higher the priority. All listeners with priority _n_ are processed before listeners of priority _n_-1. If two or more listeners share the same priority, they are processed in the order in which they were added. The default priority is 0.

  - ##### Optional useWeakReference: boolean

    Determines whether the reference to the listener is strong or weak. A strong reference(the default) prevents your listener from being garbage-collected. A weak reference does not.

                            Class-level member functions are not subject to
                            garbage collection, so you can set
                            `useWeakReference` to `true`
                            for class-level member functions without
                            subjecting them to garbage collection. If you set
                            `useWeakReference` to `true`
                            for a listener that is a nested inner function,
                            the function will be garbage-collected and no
                            longer persistent. If you create references to the
                            inner function(save it in another variable) then
                            it is not garbage-collected and stays
                            persistent.

  #### Returns void

### addTile

- addTile(tile: Tile): Tile

- - Defined in lib/openfl/display/Tilemap.d.ts:29

  #### Parameters

  - ##### tile: Tile

  #### Returns Tile

### addTileAt

- addTileAt(tile: Tile, index: number): Tile

- - Defined in lib/openfl/display/Tilemap.d.ts:31

  #### Parameters

  - ##### tile: Tile

  - ##### index: number

  #### Returns Tile

### addTiles

- addTiles(tiles: Array<Tile>): Array<Tile>

- - Defined in lib/openfl/display/Tilemap.d.ts:30

  #### Parameters

  - ##### tiles: Array<Tile>

  #### Returns Array<Tile>

### contains

- contains(tile: Tile): boolean

- - Defined in lib/openfl/display/Tilemap.d.ts:32

  #### Parameters

  - ##### tile: Tile

  #### Returns boolean

### dispatchEvent

- dispatchEvent(event: Event): boolean

- Inherited from EventDispatcher.dispatchEvent

  - Defined in lib/openfl/events/EventDispatcher.d.ts:186

  Dispatches an event into the event flow. The event target is the EventDispatcher object upon which the `dispatchEvent()` method is called.

  throws

    Error The event dispatch recursion limit has been reached.

  #### Parameters

  - ##### event: Event

    The Event object that is dispatched into the event flow. If the event is being redispatched, a clone of the event is created automatically. After an event is dispatched, its `target` property cannot be changed, so you must create a new copy of the event for redispatching to work.

  #### Returns boolean

  A value of `true` if the event was successfully dispatched. A value of `false` indicates failure or that `preventDefault()` was called on the event.

### getBounds

- getBounds(targetCoordinateSpace: DisplayObject): Rectangle

- Inherited from DisplayObject.getBounds

  - Defined in lib/openfl/display/DisplayObject.d.ts:799

  Returns a rectangle that defines the area of the display object relative to the coordinate system of the `targetCoordinateSpace` object. Consider the following code, which shows how the rectangle returned can vary depending on the `targetCoordinateSpace` parameter that you pass to the method:

  Note: Use the `localToGlobal()` and `globalToLocal()` methods to convert the display object's local coordinates to display coordinates, or display coordinates to local coordinates, respectively.

  The `getBounds()` method is similar to the `getRect()` method; however, the Rectangle returned by the `getBounds()` method includes any strokes on shapes, whereas the Rectangle returned by the `getRect()` method does not. For an example, see the description of the `getRect()` method.

  #### Parameters

  - ##### targetCoordinateSpace: DisplayObject

    The display object that defines the coordinate system to use.

  #### Returns Rectangle

  The rectangle that defines the area of the display object relative to the `targetCoordinateSpace` object's coordinate system.

### getRect

- getRect(targetCoordinateSpace: DisplayObject): Rectangle

- Inherited from DisplayObject.getRect

  - Defined in lib/openfl/display/DisplayObject.d.ts:820

  Returns a rectangle that defines the boundary of the display object, based on the coordinate system defined by the `targetCoordinateSpace` parameter, excluding any strokes on shapes. The values that the `getRect()` method returns are the same or smaller than those returned by the `getBounds()` method.

  Note: Use `localToGlobal()` and `globalToLocal()` methods to convert the display object's local coordinates to Stage coordinates, or Stage coordinates to local coordinates, respectively.

  #### Parameters

  - ##### targetCoordinateSpace: DisplayObject

    The display object that defines the coordinate system to use.

  #### Returns Rectangle

  The rectangle that defines the area of the display object relative to the `targetCoordinateSpace` object's coordinate system.

### getTileAt

- getTileAt(index: number): Tile

- - Defined in lib/openfl/display/Tilemap.d.ts:33

  #### Parameters

  - ##### index: number

  #### Returns Tile

### getTileIndex

- getTileIndex(tile: Tile): number

- - Defined in lib/openfl/display/Tilemap.d.ts:34

  #### Parameters

  - ##### tile: Tile

  #### Returns number

### getTiles

- getTiles(): TileContainer

- - Defined in lib/openfl/display/Tilemap.d.ts:35

  #### Returns TileContainer

### Protected get_alpha

- get_alpha(): number

- Inherited from DisplayObject.get_alpha

  - Defined in lib/openfl/display/DisplayObject.d.ts:163

  #### Returns number

### Protected get_blendMode

- get_blendMode(): BlendMode

- Inherited from DisplayObject.get_blendMode

  - Defined in lib/openfl/display/DisplayObject.d.ts:192

  #### Returns BlendMode

### Protected get_cacheAsBitmap

- get_cacheAsBitmap(): boolean

- Inherited from DisplayObject.get_cacheAsBitmap

  - Defined in lib/openfl/display/DisplayObject.d.ts:253

  #### Returns boolean

### Protected get_cacheAsBitmapMatrix

- get_cacheAsBitmapMatrix(): Matrix

- Inherited from DisplayObject.get_cacheAsBitmapMatrix

  - Defined in lib/openfl/display/DisplayObject.d.ts:258

  #### Returns Matrix

### Protected get_filters

- get_filters(): Array<BitmapFilter>

- Inherited from DisplayObject.get_filters

  - Defined in lib/openfl/display/DisplayObject.d.ts:339

  #### Returns Array<BitmapFilter>

### Protected get_height

- get_height(): number

- Inherited from DisplayObject.get_height

  - Defined in lib/openfl/display/DisplayObject.d.ts:354

  #### Returns number

### Protected get_loaderInfo

- get_loaderInfo(): LoaderInfo

- Inherited from DisplayObject.get_loaderInfo

  - Defined in lib/openfl/display/DisplayObject.d.ts:372

  #### Returns LoaderInfo

### Protected get_mask

- get_mask(): DisplayObject

- Inherited from DisplayObject.get_mask

  - Defined in lib/openfl/display/DisplayObject.d.ts:407

  #### Returns DisplayObject

### Protected get_mouseX

- get_mouseX(): number

- Inherited from DisplayObject.get_mouseX

  - Defined in lib/openfl/display/DisplayObject.d.ts:419

  #### Returns number

### Protected get_mouseY

- get_mouseY(): number

- Inherited from DisplayObject.get_mouseY

  - Defined in lib/openfl/display/DisplayObject.d.ts:430

  #### Returns number

### Protected get_name

- get_name(): string

- Inherited from DisplayObject.get_name

  - Defined in lib/openfl/display/DisplayObject.d.ts:444

  #### Returns string

### Protected get_numTiles

- get_numTiles(): number

- - Defined in lib/openfl/display/Tilemap.d.ts:17

  #### Returns number

### Protected get_root

- get_root(): DisplayObject

- Inherited from DisplayObject.get_root

  - Defined in lib/openfl/display/DisplayObject.d.ts:517

  #### Returns DisplayObject

### Protected get_rotation

- get_rotation(): number

- Inherited from DisplayObject.get_rotation

  - Defined in lib/openfl/display/DisplayObject.d.ts:529

  #### Returns number

### Protected get_scaleX

- get_scaleX(): number

- Inherited from DisplayObject.get_scaleX

  - Defined in lib/openfl/display/DisplayObject.d.ts:606

  #### Returns number

### Protected get_scaleY

- get_scaleY(): number

- Inherited from DisplayObject.get_scaleY

  - Defined in lib/openfl/display/DisplayObject.d.ts:619

  #### Returns number

### Protected get_scrollRect

- get_scrollRect(): Rectangle

- Inherited from DisplayObject.get_scrollRect

  - Defined in lib/openfl/display/DisplayObject.d.ts:650

  #### Returns Rectangle

### Protected get_shader

- get_shader(): Shader

- Inherited from DisplayObject.get_shader

  - Defined in lib/openfl/display/DisplayObject.d.ts:655

  #### Returns Shader

### Protected get_stage

- get_stage(): Stage

- Inherited from DisplayObject.get_stage

  - Defined in lib/openfl/display/DisplayObject.d.ts:670

  #### Returns Stage

### Protected get_tileset

- get_tileset(): Tileset

- - Defined in lib/openfl/display/Tilemap.d.ts:24

  #### Returns Tileset

### Protected get_transform

- get_transform(): Transform

- Inherited from DisplayObject.get_transform

  - Defined in lib/openfl/display/DisplayObject.d.ts:713

  #### Returns Transform

### Protected get_visible

- get_visible(): boolean

- Inherited from DisplayObject.get_visible

  - Defined in lib/openfl/display/DisplayObject.d.ts:723

  #### Returns boolean

### Protected get_width

- get_width(): number

- Inherited from DisplayObject.get_width

  - Defined in lib/openfl/display/DisplayObject.d.ts:738

  #### Returns number

### Protected get_x

- get_x(): number

- Inherited from DisplayObject.get_x

  - Defined in lib/openfl/display/DisplayObject.d.ts:753

  #### Returns number

### Protected get_y

- get_y(): number

- Inherited from DisplayObject.get_y

  - Defined in lib/openfl/display/DisplayObject.d.ts:768

  #### Returns number

### globalToLocal

- globalToLocal(pos: Point): Point

- Inherited from DisplayObject.globalToLocal

  - Defined in lib/openfl/display/DisplayObject.d.ts:840

  Converts the `point` object from the Stage(global) coordinates to the display object's(local) coordinates.

  To use this method, first create an instance of the Point class. The _x_ and _y_ values that you assign represent global coordinates because they relate to the origin(0,0) of the main display area. Then pass the Point instance as the parameter to the `globalToLocal()` method. The method returns a new Point object with _x_ and _y_ values that relate to the origin of the display object instead of the origin of the Stage.

  #### Parameters

  - ##### pos: Point

  #### Returns Point

  A Point object with coordinates relative to the display object.

### hasEventListener

- hasEventListener(type: string): boolean

- Inherited from EventDispatcher.hasEventListener

  - Defined in lib/openfl/events/EventDispatcher.d.ts:209

  Checks whether the EventDispatcher object has any listeners registered for a specific type of event. This allows you to determine where an EventDispatcher object has altered handling of an event type in the event flow hierarchy. To determine whether a specific event type actually triggers an event listener, use `willTrigger()`.

  The difference between `hasEventListener()` and `willTrigger()` is that `hasEventListener()` examines only the object to which it belongs, whereas `willTrigger()` examines the entire event flow for the event specified by the `type` parameter.

  When `hasEventListener()` is called from a LoaderInfo object, only the listeners that the caller can access are considered.

  #### Parameters

  - ##### type: string

    The type of event.

  #### Returns boolean

  A value of `true` if a listener of the specified type is registered; `false` otherwise.

### hitTestObject

- hitTestObject(obj: DisplayObject): boolean

- Inherited from DisplayObject.hitTestObject

  - Defined in lib/openfl/display/DisplayObject.d.ts:856

  Evaluates the bounding box of the display object to see if it overlaps or intersects with the bounding box of the `obj` display object.

  #### Parameters

  - ##### obj: DisplayObject

    The display object to test against.

  #### Returns boolean

  `true` if the bounding boxes of the display objects intersect; `false` if not.

### hitTestPoint

- hitTestPoint(x: number, y: number, shapeFlag?: boolean): boolean

- Inherited from DisplayObject.hitTestPoint

  - Defined in lib/openfl/display/DisplayObject.d.ts:875

  Evaluates the display object to see if it overlaps or intersects with the point specified by the `x` and `y` parameters. The `x` and `y` parameters specify a point in the coordinate space of the Stage, not the display object container that contains the display object(unless that display object container is the Stage).

  #### Parameters

  - ##### x: number

    The _x_ coordinate to test against this object.

  - ##### y: number

    The _y_ coordinate to test against this object.

  - ##### Optional shapeFlag: boolean

    Whether to check against the actual pixels of the object (`true`) or the bounding box (`false`).

  #### Returns boolean

  `true` if the display object overlaps or intersects with the specified point; `false` otherwise.

### invalidate

- invalidate(): void

- Inherited from DisplayObject.invalidate

  - Defined in lib/openfl/display/DisplayObject.d.ts:882

  Calling the `invalidate()` method signals to have the current object redrawn the next time the object is eligible to be rendered.

  #### Returns void

### localToGlobal

- localToGlobal(point: Point): Point

- Inherited from DisplayObject.localToGlobal

  - Defined in lib/openfl/display/DisplayObject.d.ts:907

  Converts the `point` object from the display object's(local) coordinates to the Stage(global) coordinates.

  This method allows you to convert any given _x_ and _y_ coordinates from values that are relative to the origin(0,0) of a specific display object(local coordinates) to values that are relative to the origin of the Stage(global coordinates).

  To use this method, first create an instance of the Point class. The _x_ and _y_ values that you assign represent local coordinates because they relate to the origin of the display object.

  You then pass the Point instance that you created as the parameter to the `localToGlobal()` method. The method returns a new Point object with _x_ and _y_ values that relate to the origin of the Stage instead of the origin of the display object.

  #### Parameters

  - ##### point: Point

    The name or identifier of a point created with the Point class, specifying the _x_ and _y_ coordinates as properties.

  #### Returns Point

  A Point object with coordinates relative to the Stage.

### removeEventListener

- removeEventListener(type: string, listener: function, useCapture?: boolean): void

- Inherited from EventDispatcher.removeEventListener

  - Defined in lib/openfl/events/EventDispatcher.d.ts:227

  Removes a listener from the EventDispatcher object. If there is no matching listener registered with the EventDispatcher object, a call to this method has no effect.

  #### Parameters

  - ##### type: string

    The type of event.

  - ##### listener: function

    - - (event: object): void

      - #### Parameters

        - ##### event: object

        #### Returns void

  - ##### Optional useCapture: boolean

    Specifies whether the listener was registered for the capture phase or the target and bubbling phases. If the listener was registered for both the capture phase and the target and bubbling phases, two calls to `removeEventListener()` are required to remove both, one call with `useCapture()` set to `true`, and another call with `useCapture()` set to `false`.

  #### Returns void

### removeTile

- removeTile(tile: Tile): Tile

- - Defined in lib/openfl/display/Tilemap.d.ts:36

  #### Parameters

  - ##### tile: Tile

  #### Returns Tile

### removeTileAt

- removeTileAt(index: number): Tile

- - Defined in lib/openfl/display/Tilemap.d.ts:37

  #### Parameters

  - ##### index: number

  #### Returns Tile

### removeTiles

- removeTiles(beginIndex?: number, endIndex?: number): void

- - Defined in lib/openfl/display/Tilemap.d.ts:38

  #### Parameters

  - ##### Optional beginIndex: number

  - ##### Optional endIndex: number

  #### Returns void

### setTileIndex

- setTileIndex(tile: Tile, index: number): void

- - Defined in lib/openfl/display/Tilemap.d.ts:39

  #### Parameters

  - ##### tile: Tile

  - ##### index: number

  #### Returns void

### setTiles

- setTiles(group: TileContainer): void

- - Defined in lib/openfl/display/Tilemap.d.ts:40

  #### Parameters

  - ##### group: TileContainer

  #### Returns void

### Protected set_alpha

- set_alpha(value: number): number

- Inherited from DisplayObject.set_alpha

  - Defined in lib/openfl/display/DisplayObject.d.ts:164

  #### Parameters

  - ##### value: number

  #### Returns number

### Protected set_blendMode

- set_blendMode(value: BlendMode): BlendMode

- Inherited from DisplayObject.set_blendMode

  - Defined in lib/openfl/display/DisplayObject.d.ts:193

  #### Parameters

  - ##### value: BlendMode

  #### Returns BlendMode

### Protected set_cacheAsBitmap

- set_cacheAsBitmap(value: boolean): boolean

- Inherited from DisplayObject.set_cacheAsBitmap

  - Defined in lib/openfl/display/DisplayObject.d.ts:254

  #### Parameters

  - ##### value: boolean

  #### Returns boolean

### Protected set_cacheAsBitmapMatrix

- set_cacheAsBitmapMatrix(value: Matrix): Matrix

- Inherited from DisplayObject.set_cacheAsBitmapMatrix

  - Defined in lib/openfl/display/DisplayObject.d.ts:259

  #### Parameters

  - ##### value: Matrix

  #### Returns Matrix

### Protected set_filters

- set_filters(value: Array<BitmapFilter>): Array<BitmapFilter>

- Inherited from DisplayObject.set_filters

  - Defined in lib/openfl/display/DisplayObject.d.ts:340

  #### Parameters

  - ##### value: Array<BitmapFilter>

  #### Returns Array<BitmapFilter>

### Protected set_height

- set_height(value: number): number

- Inherited from DisplayObject.set_height

  - Defined in lib/openfl/display/DisplayObject.d.ts:355

  #### Parameters

  - ##### value: number

  #### Returns number

### Protected set_mask

- set_mask(value: DisplayObject): DisplayObject

- Inherited from DisplayObject.set_mask

  - Defined in lib/openfl/display/DisplayObject.d.ts:408

  #### Parameters

  - ##### value: DisplayObject

  #### Returns DisplayObject

### Protected set_name

- set_name(value: string): string

- Inherited from DisplayObject.set_name

  - Defined in lib/openfl/display/DisplayObject.d.ts:445

  #### Parameters

  - ##### value: string

  #### Returns string

### Protected set_rotation

- set_rotation(value: number): number

- Inherited from DisplayObject.set_rotation

  - Defined in lib/openfl/display/DisplayObject.d.ts:530

  #### Parameters

  - ##### value: number

  #### Returns number

### Protected set_scaleX

- set_scaleX(value: number): number

- Inherited from DisplayObject.set_scaleX

  - Defined in lib/openfl/display/DisplayObject.d.ts:607

  #### Parameters

  - ##### value: number

  #### Returns number

### Protected set_scaleY

- set_scaleY(value: number): number

- Inherited from DisplayObject.set_scaleY

  - Defined in lib/openfl/display/DisplayObject.d.ts:620

  #### Parameters

  - ##### value: number

  #### Returns number

### Protected set_scrollRect

- set_scrollRect(value: Rectangle): Rectangle

- Inherited from DisplayObject.set_scrollRect

  - Defined in lib/openfl/display/DisplayObject.d.ts:651

  #### Parameters

  - ##### value: Rectangle

  #### Returns Rectangle

### Protected set_shader

- set_shader(value: Shader): Shader

- Inherited from DisplayObject.set_shader

  - Defined in lib/openfl/display/DisplayObject.d.ts:656

  #### Parameters

  - ##### value: Shader

  #### Returns Shader

### Protected set_stage

- set_stage(value: Stage): Stage

- Inherited from DisplayObject.set_stage

  - Defined in lib/openfl/display/DisplayObject.d.ts:671

  #### Parameters

  - ##### value: Stage

  #### Returns Stage

### Protected set_tileset

- set_tileset(value: Tileset): Tileset

- - Defined in lib/openfl/display/Tilemap.d.ts:25

  #### Parameters

  - ##### value: Tileset

  #### Returns Tileset

### Protected set_transform

- set_transform(value: Transform): Transform

- Inherited from DisplayObject.set_transform

  - Defined in lib/openfl/display/DisplayObject.d.ts:714

  #### Parameters

  - ##### value: Transform

  #### Returns Transform

### Protected set_visible

- set_visible(value: boolean): boolean

- Inherited from DisplayObject.set_visible

  - Defined in lib/openfl/display/DisplayObject.d.ts:724

  #### Parameters

  - ##### value: boolean

  #### Returns boolean

### Protected set_width

- set_width(value: number): number

- Inherited from DisplayObject.set_width

  - Defined in lib/openfl/display/DisplayObject.d.ts:739

  #### Parameters

  - ##### value: number

  #### Returns number

### Protected set_x

- set_x(value: number): number

- Inherited from DisplayObject.set_x

  - Defined in lib/openfl/display/DisplayObject.d.ts:754

  #### Parameters

  - ##### value: number

  #### Returns number

### Protected set_y

- set_y(value: number): number

- Inherited from DisplayObject.set_y

  - Defined in lib/openfl/display/DisplayObject.d.ts:769

  #### Parameters

  - ##### value: number

  #### Returns number

### swapTiles

- swapTiles(tile1: Tile, tile2: Tile): void

- - Defined in lib/openfl/display/Tilemap.d.ts:41

  #### Parameters

  - ##### tile1: Tile

  - ##### tile2: Tile

  #### Returns void

### swapTilesAt

- swapTilesAt(index1: number, index2: number): void

- - Defined in lib/openfl/display/Tilemap.d.ts:42

  #### Parameters

  - ##### index1: number

  - ##### index2: number

  #### Returns void

### toString

- toString(): string

- Inherited from EventDispatcher.toString

  - Defined in lib/openfl/events/EventDispatcher.d.ts:230

  #### Returns string

### willTrigger

- willTrigger(type: string): boolean

- Inherited from EventDispatcher.willTrigger

  - Defined in lib/openfl/events/EventDispatcher.d.ts:253

  Checks whether an event listener is registered with this EventDispatcher object or any of its ancestors for the specified event type. This method returns `true` if an event listener is triggered during any phase of the event flow when an event of the specified type is dispatched to this EventDispatcher object or any of its descendants.

  The difference between the `hasEventListener()` and the `willTrigger()` methods is that `hasEventListener()` examines only the object to which it belongs, whereas the `willTrigger()` method examines the entire event flow for the event specified by the `type` parameter.

  When `willTrigger()` is called from a LoaderInfo object, only the listeners that the caller can access are considered.

  #### Parameters

  - ##### type: string

    The type of event.

  #### Returns boolean

  A value of `true` if a listener of the specified type will be triggered; `false` otherwise.

Generated using TypeDoc